diff --git a/libglusterfs/src/common-utils.c b/libglusterfs/src/common-utils.c
index 0d98b4f0d38..628a54a68e9 100644
--- a/libglusterfs/src/common-utils.c
+++ b/libglusterfs/src/common-utils.c
@@ -1179,8 +1179,10 @@ _gf_string2long(const char *str, long *n, int base)
     old_errno = errno;
     errno = 0;
     value = strtol(str, &tail, base);
-    if (str == tail)
+    if ((str == tail) || (*tail != 0)) {
         errno = EINVAL;
+        return -1;
+    }
 
     if (errno == ERANGE || errno == EINVAL)
         return -1;
@@ -1188,9 +1190,6 @@ _gf_string2long(const char *str, long *n, int base)
     if (errno == 0)
         errno = old_errno;
 
-    if (tail[0] != '\0')
-        return -1;
-
     *n = value;
 
     return 0;
